#ifndef __IP_H
#define __IP_H

#define bool char
#define true (1)
#define false (0)

// provided by host program
unsigned long get_tick_count();
void eth_init(unsigned char const *macaddr);
unsigned int eth_recv_packet(void *ptr, int maxlen);
void eth_send_packet(void const *ptr, unsigned int len);

//

struct packet_header_t {
	unsigned char src_addr[4];
	unsigned short src_port;
	unsigned short dst_port;
	unsigned short length;
	unsigned char data[0];
};

void ip_stack_init(unsigned char const *macaddr);
bool ip_config_with_dhcp();
void ip_stack_process();
bool gethostbyname(char const *name, unsigned char *ipv4);
bool send_udp_packet(unsigned char const *dstipv4, unsigned short dstport, unsigned short srcport, unsigned char const *ptr, unsigned short len);
struct packet_header_t *take_udp_packet(); // after using the buffer should be free(p);

#endif


